#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <errno.h>
#include "wllib.h"

#ifdef FOR_X11
#include "mop451.xpm" /* Ikona pro X Window System$^{\def\fntmag{\magstep.2}\rm TM}$ */
#endif

struct {
	long x,y; /* Souadnice v~gfx */
	} *ar; /* Pole vech bod */
unsigned N,p; /* $N$, souasn bod pi kreslen */

void drawgfx(void)
{ /* vykresli gfx */
	for (p=0;p<=N;p++) /* pro vechny body dokola (prvn 2-krt) */
		wl_line(ar[p==N?0:p].x,ar[p==N?0:p].y); /* spoj ru */
}

int main(int argc,char **argv)
{
int i,j,rot=0,nkvx=0; /* pomocn, pomocn, smr uhbn, nen konvexn */
long x,y; /* pro natn (zdrojov sou.) */
float k=sin((float)60);
	wl_init(&argc,argv,"MOP451"); /* inicializuj gfx */
	if (scanf("%u",&N)!=1) iofailn(EINVAL); /* nati $N$ */
	if (N<3) iofailn(EINVAL); /* chceme mnohohelnk */
	if (!(ar=malloc(N*sizeof(*ar)))) iofail(); /* pole bod */
	for (i=0;i<N+1;i++) { /* na konci otestujeme jet prvn body */
		if (i<N) { /* jsme-li jet v~natn */
			if (scanf("%ld %ld",&x,&y)!=2) iofailn(EINVAL);
			x<<=4; y<<=4; /* pro zvten pesnosti vykreslovn */
			ar[i].x=x+y/2; ar[i].y=rint(k*y); /* peve na pravohl sou. */
			}
#define A(q) ar[(q)>=N?(q)-N:(q)] /* pole se zrcadlem */
		if (i>=2&&!nkvx) if ((j=(A(i-1).x-A(i-2).x)*(A(i).y-A(i-2).y)
				-(A(i-1).y-A(i-2).y)*(A(i).x-A(i-2).x))) { /* do \var j dej zatoen sou. bodu */
#undef A
			if (rot) nkvx|=j!=rot; /* vme-li ji, kam zatme, otestuj konvexnost */
			else rot=j; /* nynji vme, kam zatme */
			}
		}
	if (!rot) iofailn(EINVAL); /* vechny body nleely pmce */
	printf("Zadan %u-helnk %s konvexn.\n",N,nkvx?"nen":"je");
	wl_done(); /* gfx okno */
	return(nkvx); /* hotovo */
}
