#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <limits.h>
#include <errno.h>
#include "wllib.h"

#ifdef FOR_X11
#include "mop453.xpm" /* Ikona pro X Window System$^{\def\fntmag{\magstep.2}\rm TM}$ */
#endif

#ifndef PI
#ifdef M_PI
#define PI M_PI
#else
#define PI 3.14159265358979323846
#endif
#endif

typedef long da_num; /* budeme {\I dyna-add}it \type{long}y */
#define NEED_DA_POS /* potebujeme \func{da_putpos}() a \func{da_getpos}() */
#include "dyna-add.c" /* modul dynamickho pidvn */

float curX,curY; /* souadnice pera */
int curA; /* hel natoenpera */

static void draw_seq(void)
{ /* vykresli posloupnost z~dyna-struktury */
long st1; /* prvn parametr dyna-struktury */
int i; /* pomocn */
	for (;;) { /* pro neomezen poet dvojic */
		i=da_get(&st1); assert(!!i); /* posledn prvek bude 0 */
		if (!st1) return; /* ukonen posloupnosti */
		if (st1<0) { /* prvek$<0$ $\Longrightarrow$ dv sla */
long p1; /* vzdlenost */
float k=0/*fake for GCC*/; /* hel v~radinech */
			i=da_get(&p1); assert(!!i); /* tento parametr tak musexistovat */
			curX+=p1*sin(k=(float)curA*PI/180); /* oupni prem */
			wl_line((long)rint(curX*16),(long)rint((curY+=p1*cos(k))*16)); /* thni! (\dots ru) */
			if ((curA+=st1)<0) curA+=360; /* nato pero a mon pete */
			}
		else { /* opakuj posloupnost */
struct da_pos pos; /* zapamatovnpozice pro opakovn */
			da_putpos(&pos); /* pamatuj! */
			while (st1--) { /* \var{st1}-krt */
				da_getpos(&pos); /* pro velkohlas reprza */
				draw_seq(); /* jedem znova posloupnost */
				}
			}
		}
}

void drawgfx(void)
{ /* vykresli gfx */
long n;
	da_reset(); /* nainicializuj dyna-struktury na zatek */
	wl_line((long)(curX=0),(long)(curY=0)); /* prvnbod je z~$(0,0)$ */
	curA=0; /* natoen na sever */
	draw_seq(); /* zpracuj top-level posloupnost */
	assert(!da_get(&n)); /* ujisti se, e to bylo ve */
}

static long get_lex(void)
{ /* nati lexiklnelement a vra slo,
i LONG_MIN pro \sign[ nebo LONG_MAX pro \sign] */
int c,isn=0,neg=0; /* naten znak, kousek sla?, zporn? */
long n=0; /* sestavovan slo */
	for (;;) { /* \dots a v~ivotto nikdo nezastav */
		if ((c=getchar())==EOF) iofail(); /* EOF m pijt v~\func{main}()u */
		if (c=='\n'||c=='\t') c=' '; /* white-space */
		if (c==' ') {
			if (isn) break; /* je-li kousek sla, potom oddlova */
			else continue; /* jinak ignoruj */
			}
		if (c=='['||c==']') break; /* terminuj vdy */
		if (!neg&&c=='-') { neg=1; continue; } /* zpornslo? */
		if (c<'0'||c>'9') iofailn(EINVAL); /* tady by to ji mla bt cifra */
		isn=1; /* ji mme kousek sla */
		if (n>LONG_MAX/10) iofailn(ERANGE); /* nevyteeme? */
		n=n*10+c-'0'; /* pedpoklady: destkov soustava a souvisl kdy cifer */
		}
	if (isn) { /* terminace uprosted sla */
		if (neg) n=-n; /* negativn numero */
		if (n==LONG_MIN||n==LONG_MAX) iofailn(ERANGE); /* check kolize nvratovch hodnot */
		ungetc(c,stdin); /* byla-li to hranatka, bude jetpoteba, white-space se sveze */
		}
	return(isn?n:(c=='['?LONG_MIN:LONG_MAX)); /* slo, i typ hranatky */
}

long p1,p2; /* pro chroustnposloupnosti jsou jako auto-varibly zbytenexpensive */

static void do_seq(void)
{ /* nachroustej jednu rove posloupnosti */
	while ((p1=get_lex())!=LONG_MAX) { /* dokud nenaraz na \sign] */
		if (p1==LONG_MIN) iofailn(EINVAL); /* $P_1$ mus bt slo */
		if ((p2=get_lex())==LONG_MAX) iofailn(EINVAL); /* $P_2$ nesm bt \sign] */
		if (p2==LONG_MIN) { /* bylo-li $P_2$ \sign[ */
			if (p1<=0) iofailn(EINVAL); /* $P_1$ mus bt kladn*/
			da_put(p1); /* ulo kladnslo jako opakovan */
			do_seq(); /* rekurzivn zpracuj opakovanou posloupnost */
			}
		else { /* budeme kreslit */
			p2%=360; if (p2>=0) p2-=360; /* znormalizuj hel do zporna */
			da_put(p2); da_put(p1); /* nejdv hel ($P_2$ -- odlien od opakovn),
potom dlka ($P_1$) */
			}
		}
	da_put(0); /* termintor posloupnosti */
}

int main(int argc,char **argv)
{
int i;
	wl_init(&argc,argv,"MOP453"); /* inicializuj gfx */
	if (get_lex()!=LONG_MIN) iofailn(EINVAL); /* prvn element mus bt \sign[ */
	do_seq(); /* zpracuj top-level posloupnost */
	do i=getchar(); while (i==' '||i=='\n'||i=='\t'); /* seer white-spacy */
	if (i!=EOF) iofailn(EINVAL); /* mus bt EOF, jinak ERROR */
	wl_done(); /* gfx okno */
	return(0); /* hotovo */
}
